*******************************************************************************;
* vO: P01-06-03.SAS                                                 *;
* eLXg̏: Ṕ@SAS/RpX͎̉                         *;
* eLXg̐: U߁@JeSJf[^̔r                            *;
* gpړI: kQ~c\̐`֘A                              *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: kQ~c\̐`֘A';
footnote 'Program: P01-06-03.SAS';

* ----- Tvf[^쐬;
data DT503;
  length DRUG $6;
  keep DRUG RESP;
  do DRUG='low','middle','high';
    do RESP=1 to 4;
      input KAZ @@;
      do LOOP=1 to KAZ;
        output;
      end;
    end;
  end;
  cards;
 3  4  6  9
 6  6  8  5
10  5  4  3
;
run;

proc print data=DT503;
run;

* ----- FREQANPAR1WAYvVWɂkQ~c\̐`֘A;
proc freq data=DT503 order=data;
  tables DRUG*RESP/nocol nopercent cmh scores=rank;
  output out=OUT1 cmh;
run;

proc npar1way data=DT503 wilcoxon;
  class DRUG;
  var RESP;
  output out=OUT2 wilcoxon;
run;

proc print data=OUT1;
run;

proc print data=OUT2;
run;
