*******************************************************************************;
* vO: P01-08-01.SAS                                                 *;
* eLXg̏: Ṕ@SAS/RpX͎̉                         *;
* eLXg̐: W߁@X̌                                        *;
* gpړI: A                                                          *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: X̌';
footnote 'Program: P01-08-01.SAS';

* ----- Tvf[^쐬;
data DT01;
  keep DOSE RESP;
  do DOSE=0, 10, 20, 30;
    do i=1 to 5;
      input RESP @@;
      output;
    end;
  end;
  cards;
8.06 8.27 8.45 8.51 8.14
7.97 7.66 8.05 8.30 8.03
7.66 7.71 7.88 8.05 7.80
8.00 7.89 7.79 7.91 7.40
;
run ;

proc glm data=dt01 outstat=out;
  class dose;
  model resp=dose;
  contrast 'linear' dose  -3 -1 1 3;
  contrast 'reg' dose  -7 -5 -1 13;
run;
quit;

proc print data=out;
run;
