*******************************************************************************;
* vO: P02-02-03.SAS                                                 *;
* eLXg̏: Q́@SAS/RpX̗ᐔ݌v                     *;
* eLXg̐: Q߁@QQ̔r                                      *;
* gpړI: 䗦̗Dz̗ᐔ߂                                    *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: 䗦̗Dz̗ᐔ߂';
footnote 'Program: P02-02-03.SAS';

*--- 䗦̗Dz̗ᐔ݌v ---*;
/*-----p[^w---------------------------------------------------------*/
/*  PI_A   : 팱A̗L                                                  */
/*  PI_B   : ΏƖB̗L                                                  */
/*  ALPHA  : LӐ(P̉ߌ)                                           */
/*  BETA   : 2̉ߌ                                                      */
/*  GAMMA  : 2Q̏Ǘᐔ̔(A/B)                                             */
/*----------------------------------------------------------------------------*/
%macro PR(PI_A, PI_B, ALPHA, BETA, GAMMA);
  data WORK1;
    drop PI DELTA NA_DASH;
* ----- p[^w;
    PI_A=&PI_A;
    PI_B=&PI_B;
    ALPHA=&ALPHA;
    BETA=&BETA;
    GAMMA=&GAMMA;
* ----- vZ;
    PI=(GAMMA*PI_A+PI_B)/(1+GAMMA);
    DELTA=abs(PI_A-PI_B);
    ZALPHA=probit(1-ALPHA/2);
    ZBETA=probit(1-BETA);
* ----- ᐔvZ;
    NA_DASH=(1/DELTA**2)*(ZALPHA*sqrt((1+GAMMA)*PI*(1-PI))+
    ZBETA*sqrt(PI_A*(1-PI_A)+GAMMA*PI_B*(1-PI_B)))**2;
    NA=NA_DASH/4*(1+sqrt(1+2*(1+GAMMA)/(NA_DASH*DELTA)))**2;
    NB=NA/GAMMA;
  run;

  proc print data = WORK1;
    var PI_A PI_B ALPHA BETA GAMMA ZALPHA ZBETA NA NB;
  run;
%mend;

%PR(0.65, 0.45, 0.05, 0.20, 1); 

*--- POWERvVWpꍇ ---*;
proc power;
  twosamplefreq  test = fisher
  groupproportions = (0.45 0.65)
  alpha          = 0.05
  power          = 0.80
  npergroup      = .;
run;
