*******************************************************************************;
* vO: P02-04-01.SAS                                                 *;
* eLXg̏: Q́@SAS/RpX̗ᐔ݌v                     *;
* eLXg̐: S߁@wI                                  *;
* gpړI: wIɂėᐔ߂                            *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: wIɂėᐔ߂';
footnote 'Program: P02-04-01.SAS';

*--- wI̗ᐔ݌v ---*;
/*-----p[^w---------------------------------------------------------*/
/*  MU1    : 팱̕ϒl                                                   */
/*  MU2    : ΏƖ̕ϒl                                                   */
/*  VAR    : cU                                                         */
/*  BETA   : 2̉ߌ                                                      */
/* ---------------------------------------------------------------------------*/
%macro N_BE (MU1, MU2, VAR, BETA);
  %let MAXN=100; /* N ̍őlK*/

  data BE000;
    do N=2 to &MAXN;
  * ----- p[^w;
      MU1=&MU1;
      MU2=&MU2;
      DELTA=MU1-MU2;
      VAR=&VAR;
      BETA=&BETA;
      POWER=1-&BETA;
  * ----- vZ;
      THETAL=(log(0.8)-DELTA)/sqrt(VAR/N)+tinv(0.95, 2*N-2);
      THETAU=(log(1.25)-DELTA)/sqrt(VAR/N)-tinv(0.95, 2*N-2);

      P=probt(THETAU, 2*N-2)-probt(THETAL, 2*N-2);
      FLAG=0;
  * ----- ó1|ƂȂᐔ̃`FbN;
      if P>=POWER then FLAG=1;
      output;
    end;
  run;

* ----- ó1|ƂȂŏᐔ̒o;
  data BE010;
    set BE000;
    by FLAG N;
    where FLAG=1;
    if first.FLAG;
  run;

  proc print data=BE010 noobs label;
    var MU1 MU2 DELTA VAR BETA N P;
  run;
%mend ;

%N_BE ( 1.265 , 1.346 , 0.1219 , 0.2 ) ; 

*--- POWERvVWpꍇ ---*;
proc power ;
pairedmeans test=equiv_diff dist=normal nfractional
lower=-0.223144  /*LOG(0.8)*/
upper= 0.223144  /*LOG(1.25)*/
corr=0
alpha=0.05
meandiff=-0.081
stddev=0.3491704 /*SQRT(0.12192)*/
npairs        = .
power         = 0.8;
run ;
