*******************************************************************************;
* vO: P01-01-03.SAS                                                 *;
* eLXg̏: Ṕ@SAS/RpX͎̉                         *;
* eLXg̐: P߁@f[^̗v                                        *;
* gpړI: f[^͐KzHiKxj                                  *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: f[^͐KzHiKxj';
footnote 'Program: P01-01-03.SAS';


data RBC;
  input NO RBC @@;
  cards;
 1 392  2 585  3 410  4 414  5 384  6 423  7 456  8 549  9 455 10 406
11 470 12 402 13 416 14 431 15 435 16 413 17 468 18 435 19 432 20 438
21 425 22 392 23 410 24 498 25 475 26 431 27 460 28 440 29 420 30 422
31 409 32 417 33 370 34 500 35 501 36 478 37 454 38 444 39 447 40 393
41 446 42 454 43 500 44 433 45 444 46 427 47 412 48 433 49 460 50 434
;
run;
data RBC2;set RBC;
  if              RBC<400 then CAT=1;
  if RBC>=400 and RBC<430 then CAT=2;
  if RBC>=430 and RBC<460 then CAT=3;
  if RBC>=460 and RBC<490 then CAT=4;
  if RBC>=490             then CAT=5;
;

proc freq data=RBC2;
  tables CAT/out=out;
run;

proc print;run;

data a;
  mean=440.86;
  var=1604.61;
  n=50;
  x1=400;
  x2=430;
  x3=460;
  x4=490;
  z1=(x1-mean)/sqrt(var);
  z2=(x2-mean)/sqrt(var);
  z3=(x3-mean)/sqrt(var);
  z4=(x4-mean)/sqrt(var);
  cp1=probnorm(z1);
  cp2=probnorm(z2);
  cp3=probnorm(z3);
  cp4=probnorm(z4);
  p1=cp1;
  p2=cp2-p1;
  p3=cp3-cp2;
  p4=cp4-cp3;
  p5=1-cp4;

;
proc print; var p1-p5;run;

proc freq data=RBC2;
  tables cat/testp=(0.15386,
                    0.23930,
                    0.29045,
                    0.20643,
                    0.10996
);
run;

data;
  prob=1-probchi(4.4005,2);

proc print;run;

