*******************************************************************************;
* vO: P01-03-03.SAS                                                 *;
* eLXg̏: Ṕ@SAS/RpX͎̉                         *;
* eLXg̐: R߁@Q̕ϒl̔r                                  *;
* gpړI: U                                                        *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: U';
footnote 'Program: P01-03-03.SAS';

* ----- Tvf[^쐬;
data ANCOVA;
  input GUN $ ID $ AGE BP @@;
  cards;
A1  01  44  190 A1  02  36  140 A1  03  57  270 A1  04  39  126 A1  05  32   98 
A1  06  41  212 A1  07  46  161 A1  08  41  180 A1  09  40  115 A1  10  46  135 
A1  11  41  198 A1  12  62  217 A1  13  44  150 A1  14  30   64 A1  15  44  151 
A1  16  52  189 A1  17  49  219 A1  18  48  181 A1  19  40  203 A1  20  48  229 
A1  21  33  139 A1  22  46  133 A1  23  44  159 A1  24  35  227 A1  25  38  182 
A1  26  40  165 A1  27  52  164 A1  28  43  199 A1  29  47  161 A1  30  55  210 
A1  31  48  213 A1  32  25  152 A2  51  45  221 A2  52  58  197 A2  53  66  125 
A2  54  62  235 A2  55  64  253 A2  56  50  167 A2  57  54  260 A2  58  66  234 
A2  59  50  172 A2  60  35  168 A2  61  61  220 A2  62  57  191 A2  63  43  127 
A2  64  68  329 A2  65  48  141 A2  66  66  284 A2  67  44  225 A2  68  59  215 
A2  69  59  197 A2  70  51  127 A2  71  52  207                               
;
run;

* ----- CORRvVWAREGvVWɂ鑊ւ邩̌;
proc corr data=ANCOVA;
  var AGE BP;
  by GUN;
run;

proc reg data=ANCOVA;
  model BP=AGE;
  by GUN;
run;

* ----- QʂɎUz}쐬;
proc plot data=ANCOVA;
  plot BP*AGE/haxis=0 to 70 by 5 
              vaxis=0 to 350 by 50;
  by GUN;
quit;

* ----- GLMvVWɂAš;
proc glm data=ANCOVA;
  class GUN;
  model BP=GUN AGE GUN*AGE / ss2;
quit;

* ----- GLMvVWɂAԂ̍̌;
proc glm data=ANCOVA;
  class GUN;
  model BP=GUN AGE / solution ss2;
  lsmeans GUN /stderr pdiff;
quit; 

