*******************************************************************************;
* vO: P01-04-01.SAS                                                 *;
* eLXg̏: Ṕ@SAS/RpX͎̉                         *;
* eLXg̐: S߁@ւƉA                                          *;
* gpړI: Pearson̐ϗ֌WASpearman̏ʑ֌W                     *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=25 nodate;
title 'Title: Pearson̐ϗ֌WASpearman̏ʑ֌W';
footnote 'Program: P01-04-01.SAS';

* ----- Tvf[^쐬;
data DT01;
  input NO X Y @@;
cards;
 1 33 20   2 24  4   3 30 50   4 50 10  5 42 78   6 15  3   7  5  2   8 56  4 
 9 13  6  10 45 56  11 44 42  12 21  5 13  8  5  14 31 71  15 27  9  16 40  6 
;
run ;

proc print data=DT01;
run;

* ----- CORRvVWAREGvVWɂ鑊֌W̌vZ;
ods output PearsonCorr=B;
ods output SimpleStats=C;
proc corr data=DT01 outp=OUT pearson spearman;
  var X Y;
run;

data B;merge B C;
  if Variable="X";
  keep Y PY NObs;
run;

data B;
  set B;
  Z=0.5*log((1+y)/(1-y));
  ZU=Z+probit(1-0.05/2)/sqrt(Nobs-3);
  ZL=Z-probit(1-0.05/2)/sqrt(Nobs-3);
  UPPER=(exp(ZU*2)-1)/(exp(2*ZU)+1);
  LOWER=(exp(ZL*2)-1)/(exp(2*ZL)+1);
  drop Z ZU ZL;
run;

proc print data=OUT;
run;

proc print data=B;
run;

