*******************************************************************************;
* vO: P01-06-04.SAS                                                 *;
* eLXg̏: Ṕ@SAS/RpX͎̉                         *;
* eLXg̐: U߁@JeSJf[^̔r                            *;
* gpړI: Friedman                                                      *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: Friedman';
footnote 'Program: P01-06-04.SAS';

* ----- Tvf[^쐬;
data DT04;
  do GUN=1 to 5;
    do R=1 to 8;
      input Y @@;
      output;
    end;
  end;
  cards;
101 150  88 135  60 108 120 145
 83 198  95 100  52  68 114  68
108 183  90  71  62  82  85 114
 74 145 112  58  75  77 104  67
 87 140  50  52  52  65  73  63
;
run;

proc print data=DT04;
run;

* ----- FREQvVWɂFriedman;
proc freq data=DT04;
  tables R*GUN*Y/noprint cmh2 scores=rank;
  output out=OUT cmh2;
run;

proc print data=OUT;
run;
