*******************************************************************************;
* vO: P02-02-05.SAS                                                 *;
* eLXg̏: Q́@SAS/RpX̗ᐔ݌v                     *;
* eLXg̐: Q߁@QQ̔r                                      *;
* gpړI: 䗦̔򐫋yѓ̗ᐔ߂                          *;
* Date: 2021/8/19  Version: 1.1                                               *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: 䗦̔򐫋yѓ̗ᐔ߂';
footnote 'Program: P02-02-05.SAS';

*--- 䗦̔򐫋yѓ̗ᐔ݌v ---*;
/*-----p[^w------------------------------------------------*/
/*  P        : ʂ̕L                                        */
/*  DELTA    : 򐫃}[WiEj                            */
/*  ALPHA    : БLӐ                                          */
/*  N1       : ǗᐔiJnj                                        */
/*  N2       : ǗᐔiIj                                        */
/*  INTERVAL : ǗᐔiԊuj                                        */
/*-------------------------------------------------------------------*/
%macro NONINF(P,DELTA,ALPHA,N1,N2,INTERVAL);
  data a;
/*L̍Ŗސl߂B݌@->񕪖@  Cɋ܂  */
    P=&P;
    DELTA=&DELTA;
    A=&P;
/* ̉̕Ƃ1>P*>=PɉB */
    B=0.99;
 /*̏㉺A,BŎw肷BȂB=1Ƃ͂ȂȂ̂ŋߎlw肷B*/
      IMAX=0;
      if (B< A) then do;
          C=A;
          A=B;
          B=C;
      end;
    FA=(&P-(A-&DELTA))/((A-&DELTA)*(1-A+&DELTA))+(&P-A)/(A*(1-A));
    if FA=0 then goto ED;
     
    FB=(&P-(B-&DELTA))/((B-&DELTA)*(1-B+&DELTA))+(&P-B)/(B*(1-B));
    if FB=0 then goto ED;

    do I=0 to 100;
        C=(A+B)/2;
        if ((C-A)<=1.0E-7 or (B-C)<=1.0E-7) then continue;

        FC=(&P-(C-&DELTA))/((C-&DELTA)*(1-C+&DELTA))+(&P-C)/(C*(1-C));
        if FC=0 then goto ED;

        if  (FC>0) and (FA>0) then do;
           A=C;
           FA=FC;
        end;
        else do;
           B=C;
           FB=FC;
        end;
     end;
   ed:
   keep C;
 run;

 data power;
 set a;
 * ----- p[^w;
   P=&P;
   DELTA=&DELTA;
   ALPHA=&ALPHA;
 * -----vZ;
   PP=c;
 /*  PP       : L̍Ŗސl                                  */
   Q=1-P;
   QQ=1-PP;
   do N=&N1 to &N2 by &INTERVAL;
   * -----power1F򐫎̌o;
       power1=probnorm((DELTA*sqrt(N)-1/sqrt(N)-probit(1-ALPHA)*sqrt(PP*QQ+(PP-DELTA)*(QQ+DELTA)))/sqrt(2*P*Q));
   * -----power2F̌o;
       power2=2*probnorm((DELTA*sqrt(N)-1/sqrt(N)-probit(1-ALPHA)*sqrt(PP*QQ+(PP-DELTA)*(QQ+DELTA)))/sqrt(2*P*Q))-1;
       output;
   end;
 run;
 proc print;
    var P PP DELTA ALPHA Q QQ N POWER1 POWER2;
 run;
%mend;

option symbolgen mprint;
%NONINF(0.75,0.1,0.05,200,400,10);

*--- POWERvVWpꍇ ---*;
proc power;
  twosamplefreq  test = FM
  sides          = U
  groupproportions = (0.75 0.75)
  nullpdiff      = -0.10
  alpha          = 0.05
  power          = 0.80
  npergroup      = .;
run;
